﻿
@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="row">
    <div class="col-md-4">
        <h2>@Html.ActionLink("Historical Data (CSV)", "CsvHistory")</h2>
        <p>
            Uses the Yahoo Finance CSV API and a service proxy in ChartsController to get around the same-origin policy for
            cross site scripting. CSV details are returned and parsed into script values. See service problems.
        </p>
    </div>
    <div class="col-md-4">
        <h2>@Html.ActionLink("Historical Data (JSON)", "JsonHistory")</h2>
        <p>
            Uses the Yahoo Finance YQL API to return JSON values. No service proxy is required but the web application is still
            needed because a script origin domain value is needed. (Running this directly from the file system confuses the service.)
            See service problems.
        </p>
    </div>
    <div class="col-md-4">
        <h2>@Html.ActionLink("Live Quotes (JSON)", "JsonLive")</h2>
        <p>
            Uses the Yahoo Finance YQL API to return JSON values. No service proxy is required but the web application is still
            needed because a script origin domain value is needed. (Running this directly from the file system confuses the service.)
            See service problems.
        </p>
    </div>
</div>
<div class="row">
    <div class="col-md-4">
        <h2>Script-Only Version</h2>
        <p>
            There is a client-side script-only version that demonstrates all of the same stuff in finer granularity without
            needing to make service requests to third party sources for data. I personally think that one is more interesting
            as it suggests a more specialized application that can provide finer controls over historical performance data,
            even though it doesn't demonstrate making AJAX calls or addressing your spefific requirements for stocks.
        </p>
        <p>
            <strong>Look for jsChartSimple directory</strong> next to this project on disk. You should be able to run jsChart.html in
            isolation directly from there. That is where I started before deciding I needed to proxy service calls for stocks.
        </p>
    </div>
    <div class="col-md-4">
        <h2>Services Adopted</h2>
        <p>
            I'm using the <strong>Yahoo Finance CSV and YQL APIs</strong> for these demos. The CSV API requires a service proxy passthrough
            in order to get around same origin policy limitations in client script, but the YQL APIs are a bit more open
            and are able to return JSON to any origin host. (However, this still means that the web application is needed
            because just running a static HTML file from the file system doesn't offer an actual origin host name, so script
            calls to the third party domains are rejected in that context.)
        </p>
        <p>
            I originally tried to use the Google Finance CSV API because it seemed to give me a larger data set and
            was more easilly accessed without having to include the service proxy. It is no longer supported, however, and
            the responses from the service seemed to ignore whatever dates I tried to pass into it.
        </p>
    </div>
    <div class="col-md-4">
        <h2>Service Problems</h2>
        <p>
            The free stock services are convenient but limited. Even though the application works as intended (and you can
            verify the requests that are being made by watching the script console or by using something like Fidler), the services
            don't offer either long term historical data or live intra-day information. I can get end of day quotes over time up
            to a few months at a time, or I can get single current value quotes, one at a time. The free services don't provide
            the granularity of data that your excercise requirements are asking for, so you may decide to see this as a failure.
        </p>
        <p>
            You might want to look at the stand-alone script-only performance chart demo located in the file system next to this project
            in a directory called jsChartSimple to see an example with more live, though simulated, information getting rendered.
        </p>
        <p>
            Also, in general, a more fully developed application would be better hardened against exceptions and the code could
            be streamlined quite a lot, I think.
        </p>
    </div>
</div>